Index: /pjproject/trunk/pjlib/include/pj/ssl_sock.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/ssl_sock.h	(revision 5937)
+++ /pjproject/trunk/pjlib/include/pj/ssl_sock.h	(revision 5938)
@@ -706,4 +706,5 @@
      */
     PJ_SSL_SOCK_PROTO_SSL23   = (1 << 16) - 1,
+    PJ_SSL_SOCK_PROTO_ALL = PJ_SSL_SOCK_PROTO_SSL23,
 
     /**
Index: /pjproject/trunk/pjlib/src/pj/ssl_sock_gtls.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/ssl_sock_gtls.c	(revision 5937)
+++ /pjproject/trunk/pjlib/src/pj/ssl_sock_gtls.c	(revision 5938)
@@ -45,8 +45,10 @@
     (PJ_SSL_SOCK_IMP == PJ_SSL_SOCK_IMP_GNUTLS)
 
+#define SSL_SOCK_IMP_USE_CIRC_BUF
+
+#include "ssl_sock_imp_common.h"
+#include "ssl_sock_imp_common.c"
+
 #define THIS_FILE               "ssl_sock_gtls.c"
-
-/* Workaround for ticket #985 */
-#define DELAYED_CLOSE_TIMEOUT   200
 
 /* Maximum ciphers */
@@ -70,286 +72,16 @@
 
 
-/* TLS state enumeration. */
-enum tls_connection_state {
-    TLS_STATE_NULL,
-    TLS_STATE_HANDSHAKING,
-    TLS_STATE_ESTABLISHED
-};
-
-/* Internal timer types. */
-enum timer_id {
-    TIMER_NONE,
-    TIMER_HANDSHAKE_TIMEOUT,
-    TIMER_CLOSE
-};
-
-/* Structure of SSL socket read buffer. */
-typedef struct read_data_t {
-    void *data;
-    pj_size_t len;
-} read_data_t;
-
-/*
- * Get the offset of pointer to read-buffer of SSL socket from read-buffer
- * of active socket. Note that both SSL socket and active socket employ
- * different but correlated read-buffers (as much as async_cnt for each),
- * and to make it easier/faster to find corresponding SSL socket's read-buffer
- * from known active socket's read-buffer, the pointer of corresponding
- * SSL socket's read-buffer is stored right after the end of active socket's
- * read-buffer.
- */
-#define OFFSET_OF_READ_DATA_PTR(ssock, asock_rbuf) \
-                                        (read_data_t**) \
-                                        ((pj_int8_t *)(asock_rbuf) + \
-                                        ssock->param.read_buffer_size)
-
-/* Structure of SSL socket write data. */
-typedef struct write_data_t {
-    PJ_DECL_LIST_MEMBER(struct write_data_t);
-    pj_ioqueue_op_key_t  key;
-    pj_size_t            record_len;
-    pj_ioqueue_op_key_t *app_key;
-    pj_size_t            plain_data_len;
-    pj_size_t            data_len;
-    unsigned             flags;
-    union {
-        char             content[1];
-        const char      *ptr;
-    } data;
-} write_data_t;
-
-
-/* Structure of SSL socket write buffer (circular buffer). */
-typedef struct send_buf_t {
-    char                *buf;
-    pj_size_t            max_len;
-    char                *start;
-    pj_size_t            len;
-} send_buf_t;
-
-
-/* Circular buffer object */
-typedef struct circ_buf_t {
-    pj_size_t      cap;    /* maximum number of elements (must be power of 2) */
-    pj_size_t      readp;  /* index of oldest element */
-    pj_size_t      writep; /* index at which to write new element  */
-    pj_size_t      size;   /* number of elements */
-    pj_uint8_t    *buf;    /* data buffer */
-    pj_pool_t     *pool;   /* where new allocations will take place */
-} circ_buf_t;
-
-
 /* Secure socket structure definition. */
-struct pj_ssl_sock_t {
-    pj_pool_t            *pool;
-    pj_ssl_sock_t        *parent;
-    pj_ssl_sock_param     param;
-    pj_ssl_sock_param     newsock_param;
-    pj_ssl_cert_t        *cert;
-
-    pj_ssl_cert_info      local_cert_info;
-    pj_ssl_cert_info      remote_cert_info;
-
-    pj_bool_t             is_server;
-    enum tls_connection_state connection_state;
-    pj_ioqueue_op_key_t   handshake_op_key;
-    pj_timer_entry        timer;
-    pj_status_t           verify_status;
-
-    int                   last_err;
-
-    pj_sock_t             sock;
-    pj_activesock_t      *asock;
-
-    pj_sockaddr           local_addr;
-    pj_sockaddr           rem_addr;
-    int                   addr_len;
-
-    pj_bool_t             read_started;
-    pj_size_t             read_size;
-    pj_uint32_t           read_flags;
-    void                **asock_rbuf;
-    read_data_t          *ssock_rbuf;
-
-    write_data_t          write_pending;       /* list of pending writes */
-    write_data_t          write_pending_empty; /* cache for write_pending */
-    pj_bool_t             flushing_write_pend; /* flag of flushing is ongoing */
-    send_buf_t            send_buf;
-    write_data_t          send_pending; /* list of pending write to network */
+typedef struct gnutls_sock_t {
+    pj_ssl_sock_t  	  base;
 
     gnutls_session_t      session;
     gnutls_certificate_credentials_t xcred;
 
-    circ_buf_t            circ_buf_input;
-    pj_lock_t            *circ_buf_input_mutex;
-
-    circ_buf_t            circ_buf_output;
-    pj_lock_t            *circ_buf_output_mutex;
-
     int                   tls_init_count; /* library initialization counter */
-};
-
-/*
- * Certificate/credential structure definition.
- */
-struct pj_ssl_cert_t
-{
-    pj_str_t CA_file;
-    pj_str_t CA_path;
-    pj_str_t cert_file;
-    pj_str_t privkey_file;
-    pj_str_t privkey_pass;
-
-    /* Certificate buffer. */
-    pj_ssl_cert_buffer CA_buf;
-    pj_ssl_cert_buffer cert_buf;
-    pj_ssl_cert_buffer privkey_buf;
-};
-
-
-/* GnuTLS available ciphers */
-static unsigned tls_available_ciphers;
-
-/* Array of id/names for available ciphers */
-static struct tls_ciphers_t {
-    pj_ssl_cipher id;
-    const char *name;
-} tls_ciphers[MAX_CIPHERS];
+} gnutls_sock_t;
 
 /* Last error reported somehow */
 static int tls_last_error;
-
-
-/*
- *******************************************************************
- * Circular buffer functions.
- *******************************************************************
- */
-
-static pj_status_t circ_init(pj_pool_factory *factory,
-                             circ_buf_t *cb, pj_size_t cap)
-{
-    cb->cap    = cap;
-    cb->readp  = 0;
-    cb->writep = 0;
-    cb->size   = 0;
-
-    /* Initial pool holding the buffer elements */
-    cb->pool = pj_pool_create(factory, "tls-circ%p", cap, cap, NULL);
-    if (!cb->pool)
-        return PJ_ENOMEM;
-
-    /* Allocate circular buffer */
-    cb->buf = pj_pool_alloc(cb->pool, cap);
-    if (!cb->buf) {
-        pj_pool_release(cb->pool);
-        return PJ_ENOMEM;
-    }
-
-    return PJ_SUCCESS;
-}
-
-static void circ_deinit(circ_buf_t *cb)
-{
-    if (cb->pool) {
-        pj_pool_release(cb->pool);
-        cb->pool = NULL;
-    }
-}
-
-static pj_bool_t circ_empty(const circ_buf_t *cb)
-{
-    return cb->size == 0;
-}
-
-static pj_size_t circ_size(const circ_buf_t *cb)
-{
-    return cb->size;
-}
-
-static pj_size_t circ_avail(const circ_buf_t *cb)
-{
-    return cb->cap - cb->size;
-}
-
-static void circ_read(circ_buf_t *cb, pj_uint8_t *dst, pj_size_t len)
-{
-    pj_size_t size_after = cb->cap - cb->readp;
-    pj_size_t tbc = PJ_MIN(size_after, len);
-    pj_size_t rem = len - tbc;
-
-    pj_memcpy(dst, cb->buf + cb->readp, tbc);
-    pj_memcpy(dst + tbc, cb->buf, rem);
-
-    cb->readp += len;
-    cb->readp &= (cb->cap - 1);
-
-    cb->size -= len;
-}
-
-static pj_status_t circ_write(circ_buf_t *cb,
-                              const pj_uint8_t *src, pj_size_t len)
-{
-    /* Overflow condition: resize */
-    if (len > circ_avail(cb)) {
-        /* Minimum required capacity */
-        pj_size_t min_cap = len + cb->size;
-
-        /* Next 32-bit power of two */
-        min_cap--;
-        min_cap |= min_cap >> 1;
-        min_cap |= min_cap >> 2;
-        min_cap |= min_cap >> 4;
-        min_cap |= min_cap >> 8;
-        min_cap |= min_cap >> 16;
-        min_cap++;
-
-        /* Create a new pool to hold a bigger buffer, using the same factory */
-        pj_pool_t *pool = pj_pool_create(cb->pool->factory, "tls-circ%p",
-                                         min_cap, min_cap, NULL);
-        if (!pool)
-            return PJ_ENOMEM;
-
-        /* Allocate our new buffer */
-        pj_uint8_t *buf = pj_pool_alloc(pool, min_cap);
-        if (!buf) {
-            pj_pool_release(pool);
-            return PJ_ENOMEM;
-        }
-
-        /* Save old size, which we shall restore after the next read */
-        pj_size_t old_size = cb->size;
-
-        /* Copy old data into beginning of new buffer */
-        circ_read(cb, buf, cb->size);
-
-        /* Restore old size now */
-        cb->size = old_size;
-
-        /* Release the previous pool */
-        pj_pool_release(cb->pool);
-
-        /* Update circular buffer members */
-        cb->pool = pool;
-        cb->buf = buf;
-        cb->readp = 0;
-        cb->writep = cb->size;
-        cb->cap = min_cap;
-    }
-
-    pj_size_t size_after = cb->cap - cb->writep;
-    pj_size_t tbc = PJ_MIN(size_after, len);
-    pj_size_t rem = len - tbc;
-
-    pj_memcpy(cb->buf + cb->writep, src, tbc);
-    pj_memcpy(cb->buf, src + tbc, rem);
-
-    cb->writep += len;
-    cb->writep &= (cb->cap - 1);
-
-    cb->size += len;
-
-    return PJ_SUCCESS;
-}
 
 
@@ -491,8 +223,8 @@
 
     /* Init available ciphers */
-    if (!tls_available_ciphers) {
+    if (!ssl_cipher_num) {
         unsigned int i;
 
-        for (i = 0; i<PJ_ARRAY_SIZE(tls_ciphers); i++) {
+        for (i = 0; i<PJ_ARRAY_SIZE(ssl_ciphers); i++) {
             unsigned char id[2];
             const char *suite;
@@ -500,17 +232,17 @@
             suite = gnutls_cipher_suite_info(i, (unsigned char *)id,
                                              NULL, NULL, NULL, NULL);
-            tls_ciphers[i].id = 0;
+            ssl_ciphers[i].id = 0;
             /* usually the array size is bigger than the number of available
              * ciphers anyway, so by checking here we can exit the loop as soon
              * as either all ciphers have been added or the array is full */
             if (suite) {
-                tls_ciphers[i].id = (pj_ssl_cipher)
+                ssl_ciphers[i].id = (pj_ssl_cipher)
                     (pj_uint32_t) ((id[0] << 8) | id[1]);
-                tls_ciphers[i].name = suite;
+                ssl_ciphers[i].name = suite;
             } else
                 break;
         }
 
-        tls_available_ciphers = i;
+        ssl_cipher_num = i;
     }
 
@@ -623,4 +355,5 @@
 {
     pj_ssl_sock_t *ssock = (pj_ssl_sock_t *)ptr;
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
 
     pj_lock_acquire(ssock->circ_buf_output_mutex);
@@ -628,5 +361,5 @@
         pj_lock_release(ssock->circ_buf_output_mutex);
 
-        gnutls_transport_set_errno(ssock->session, ENOMEM);
+        gnutls_transport_set_errno(gssock->session, ENOMEM);
         return -1;
     }
@@ -644,4 +377,5 @@
 {
     pj_ssl_sock_t *ssock = (pj_ssl_sock_t *)ptr;
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
 
     pj_lock_acquire(ssock->circ_buf_input_mutex);
@@ -651,5 +385,5 @@
 
         /* Data buffers not yet filled */
-        gnutls_transport_set_errno(ssock->session, EAGAIN);
+        gnutls_transport_set_errno(gssock->session, EAGAIN);
         return -1;
     }
@@ -684,4 +418,5 @@
 static pj_status_t tls_priorities_set(pj_ssl_sock_t *ssock)
 {
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
     char buf[1024];
     char priority_buf[256];
@@ -783,5 +518,5 @@
 
     /* Set our priority string */
-    ret = gnutls_priority_set_direct(ssock->session,
+    ret = gnutls_priority_set_direct(gssock->session,
                                         cipher_list.ptr, &err);
     if (ret < 0) {
@@ -797,11 +532,12 @@
 static pj_status_t tls_trust_set(pj_ssl_sock_t *ssock)
 {
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
     int ntrusts = 0;
     int err;
 
-    err = gnutls_certificate_set_x509_system_trust(ssock->xcred);
+    err = gnutls_certificate_set_x509_system_trust(gssock->xcred);
     if (err > 0)
         ntrusts += err;
-    err = gnutls_certificate_set_x509_trust_file(ssock->xcred,
+    err = gnutls_certificate_set_x509_trust_file(gssock->xcred,
                                                  TRUST_STORE_FILE1,
                                                  GNUTLS_X509_FMT_PEM);
@@ -809,5 +545,5 @@
         ntrusts += err;
 
-    err = gnutls_certificate_set_x509_trust_file(ssock->xcred,
+    err = gnutls_certificate_set_x509_trust_file(gssock->xcred,
                                                  TRUST_STORE_FILE2,
                                                  GNUTLS_X509_FMT_PEM);
@@ -875,7 +611,13 @@
 #endif
 
+static pj_ssl_sock_t *ssl_alloc(pj_pool_t *pool)
+{
+    return (pj_ssl_sock_t *)PJ_POOL_ZALLOC_T(pool, gnutls_sock_t);
+}
+
 /* Create and initialize new GnuTLS context and instance */
-static pj_status_t tls_open(pj_ssl_sock_t *ssock)
-{
+static pj_status_t ssl_create(pj_ssl_sock_t *ssock)
+{
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
     pj_ssl_cert_t *cert;
     pj_status_t status;
@@ -888,6 +630,6 @@
     /* Even if reopening is harmless, having one instance only simplifies
      * deallocating it later on */
-    if (!ssock->tls_init_count) {
-        ssock->tls_init_count++;
+    if (!gssock->tls_init_count) {
+        gssock->tls_init_count++;
         ret = tls_init();
         if (ret < 0)
@@ -897,5 +639,5 @@
 
     /* Start this socket session */
-    ret = gnutls_init(&ssock->session, ssock->is_server ? GNUTLS_SERVER
+    ret = gnutls_init(&gssock->session, ssock->is_server ? GNUTLS_SERVER
                                                         : GNUTLS_CLIENT);
     if (ret < 0)
@@ -904,7 +646,7 @@
     /* Set the ssock object to be retrieved by transport (send/recv) and by
      * user data from this session */
-    gnutls_transport_set_ptr(ssock->session,
+    gnutls_transport_set_ptr(gssock->session,
                              (gnutls_transport_ptr_t) (uintptr_t) ssock);
-    gnutls_session_set_ptr(ssock->session,
+    gnutls_session_set_ptr(gssock->session,
                            (gnutls_transport_ptr_t) (uintptr_t) ssock);
 
@@ -921,6 +663,6 @@
     /* Set the callback that allows GnuTLS to PUSH and PULL data
      * TO and FROM the transport layer */
-    gnutls_transport_set_push_function(ssock->session, tls_data_push);
-    gnutls_transport_set_pull_function(ssock->session, tls_data_pull);
+    gnutls_transport_set_push_function(gssock->session, tls_data_push);
+    gnutls_transport_set_pull_function(gssock->session, tls_data_pull);
 
     /* Determine which cipher suite to support */
@@ -930,8 +672,8 @@
 
     /* Allocate credentials for handshaking and transmission */
-    ret = gnutls_certificate_allocate_credentials(&ssock->xcred);
+    ret = gnutls_certificate_allocate_credentials(&gssock->xcred);
     if (ret < 0)
         goto out;
-    gnutls_certificate_set_verify_function(ssock->xcred, tls_cert_verify_cb);
+    gnutls_certificate_set_verify_function(gssock->xcred, tls_cert_verify_cb);
 
     /* Load system trust file(s) */
@@ -944,10 +686,10 @@
         /* Load CA if one is specified. */
         if (cert->CA_file.slen) {
-            ret = gnutls_certificate_set_x509_trust_file(ssock->xcred,
+            ret = gnutls_certificate_set_x509_trust_file(gssock->xcred,
                                                          cert->CA_file.ptr,
                                                          GNUTLS_X509_FMT_PEM);
             if (ret < 0)
                 ret = gnutls_certificate_set_x509_trust_file(
-                		ssock->xcred,
+                		gssock->xcred,
                                 cert->CA_file.ptr,
                                 GNUTLS_X509_FMT_DER);
@@ -956,10 +698,10 @@
         }
         if (cert->CA_path.slen) {
-            ret = gnutls_certificate_set_x509_trust_dir(ssock->xcred,
+            ret = gnutls_certificate_set_x509_trust_dir(gssock->xcred,
                                                          cert->CA_path.ptr,
                                                          GNUTLS_X509_FMT_PEM);
             if (ret < 0)
                 ret = gnutls_certificate_set_x509_trust_dir(
-                		ssock->xcred,
+                		gssock->xcred,
                                 cert->CA_path.ptr,
                                 GNUTLS_X509_FMT_DER);
@@ -974,5 +716,5 @@
                                     ? cert->privkey_pass.ptr
                                     : NULL;
-            ret = gnutls_certificate_set_x509_key_file2(ssock->xcred,
+            ret = gnutls_certificate_set_x509_key_file2(gssock->xcred,
                                                         cert->cert_file.ptr,
                                                         prikey_file,
@@ -981,5 +723,5 @@
                                                         0);
             if (ret != GNUTLS_E_SUCCESS)
-                ret = gnutls_certificate_set_x509_key_file2(ssock->xcred,
+                ret = gnutls_certificate_set_x509_key_file2(gssock->xcred,
                                                             cert->cert_file.ptr,
                                                             prikey_file,
@@ -995,10 +737,10 @@
             ca.data = (unsigned char*)cert->CA_buf.ptr;
             ca.size = cert->CA_buf.slen;
-            ret = gnutls_certificate_set_x509_trust_mem(ssock->xcred,
+            ret = gnutls_certificate_set_x509_trust_mem(gssock->xcred,
                                                         &ca,
                                                         GNUTLS_X509_FMT_PEM);
             if (ret < 0)
                 ret = gnutls_certificate_set_x509_trust_mem(
-                		ssock->xcred, &ca, GNUTLS_X509_FMT_DER);
+                		gssock->xcred, &ca, GNUTLS_X509_FMT_DER);
             if (ret < 0)
                 goto out;
@@ -1017,5 +759,5 @@
                                     ? cert->privkey_pass.ptr
                                     : NULL;
-            ret = gnutls_certificate_set_x509_key_mem2(ssock->xcred,
+            ret = gnutls_certificate_set_x509_key_mem2(gssock->xcred,
                                                        &cert_buf,
                                                        &privkey_buf,
@@ -1026,5 +768,5 @@
             /*
             if (ret != GNUTLS_E_SUCCESS)
-                ret = gnutls_certificate_set_x509_key_mem2(ssock->xcred,
+                ret = gnutls_certificate_set_x509_key_mem2(gssock->xcred,
                                                            &cert_buf,
                                                            &privkey_buf,
@@ -1040,10 +782,10 @@
     /* Require client certificate if asked */
     if (ssock->is_server && ssock->param.require_client_cert)
-        gnutls_certificate_server_set_request(ssock->session,
+        gnutls_certificate_server_set_request(gssock->session,
                                               GNUTLS_CERT_REQUIRE);
 
     /* Finally set credentials for this session */
-    ret = gnutls_credentials_set(ssock->session,
-                                 GNUTLS_CRD_CERTIFICATE, ssock->xcred);
+    ret = gnutls_credentials_set(gssock->session,
+                                 GNUTLS_CRD_CERTIFICATE, gssock->xcred);
     if (ret < 0)
         goto out;
@@ -1056,20 +798,22 @@
 
 /* Destroy GnuTLS credentials and session. */
-static void tls_close(pj_ssl_sock_t *ssock)
-{
-    if (ssock->session) {
-        gnutls_bye(ssock->session, GNUTLS_SHUT_RDWR);
-        gnutls_deinit(ssock->session);
-        ssock->session = NULL;
-    }
-
-    if (ssock->xcred) {
-        gnutls_certificate_free_credentials(ssock->xcred);
-        ssock->xcred = NULL;
+static void ssl_destroy(pj_ssl_sock_t *ssock)
+{
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
+
+    if (gssock->session) {
+        gnutls_bye(gssock->session, GNUTLS_SHUT_RDWR);
+        gnutls_deinit(gssock->session);
+        gssock->session = NULL;
+    }
+
+    if (gssock->xcred) {
+        gnutls_certificate_free_credentials(gssock->xcred);
+        gssock->xcred = NULL;
     }
 
     /* Free GnuTLS library */
-    if (ssock->tls_init_count) {
-        ssock->tls_init_count--;
+    if (gssock->tls_init_count) {
+        gssock->tls_init_count--;
         tls_deinit();
     }
@@ -1082,21 +826,50 @@
 
 /* Reset socket state. */
-static void tls_sock_reset(pj_ssl_sock_t *ssock)
-{
-    ssock->connection_state = TLS_STATE_NULL;
-
-    tls_close(ssock);
-
-    if (ssock->asock) {
-        pj_activesock_close(ssock->asock);
-        ssock->asock = NULL;
-        ssock->sock = PJ_INVALID_SOCKET;
-    }
-    if (ssock->sock != PJ_INVALID_SOCKET) {
-        pj_sock_close(ssock->sock);
-        ssock->sock = PJ_INVALID_SOCKET;
-    }
+static void ssl_reset_sock_state(pj_ssl_sock_t *ssock)
+{
+    pj_lock_acquire(ssock->circ_buf_output_mutex);
+    ssock->ssl_state = SSL_STATE_NULL;
+    pj_lock_release(ssock->circ_buf_output_mutex);
+
+    ssl_close_sockets(ssock);
 
     ssock->last_err = tls_last_error = GNUTLS_E_SUCCESS;
+}
+
+
+static void ssl_ciphers_populate(void)
+{
+     if (!ssl_cipher_num) {
+         tls_init();
+         tls_deinit();
+     }
+}
+
+
+static pj_ssl_cipher ssl_get_cipher(pj_ssl_sock_t *ssock)
+{
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
+    int i;
+    gnutls_cipher_algorithm_t lookup;
+    gnutls_cipher_algorithm_t cipher;
+
+    /* Current cipher */
+    cipher = gnutls_cipher_get(gssock->session);
+    for (i = 0; ; i++) {
+        unsigned char id[2];
+        const char *suite;
+        
+        suite = gnutls_cipher_suite_info(i,(unsigned char *)id, NULL,
+                                         &lookup, NULL, NULL);
+        if (suite) {
+            if (lookup == cipher) {
+                return (pj_uint32_t) ((id[0] << 8) | id[1]);
+            }
+        } else {
+            break;
+        }
+    }
+
+    return PJ_TLS_UNKNOWN_CIPHER;
 }
 
@@ -1252,6 +1025,7 @@
 /* Update local & remote certificates info. This function should be
  * called after handshake or renegotiation successfully completed. */
-static void tls_cert_update(pj_ssl_sock_t *ssock)
-{
+static void ssl_update_certs_info(pj_ssl_sock_t *ssock)
+{
+    gnutls_sock_t *gssock = (gnutls_sock_t *)ssock;
     gnutls_x509_crt_t cert = NULL;
     const gnutls_datum_t *us;
@@ -1260,8 +1034,8 @@
     int ret = GNUTLS_CERT_INVALID;
 
-    pj_assert(ssock->connection_state == TLS_STATE_ESTABLISHED);
+    pj_assert(ssock->ssl_state == SSL_STATE_ESTABLISHED);
 
     /* Get active local certificate */
-    us = gnutls_certificate_get_ours(ssock->session);
+    us = gnutls_certificate_get_ours(gssock->session);
     if (!us)
         goto us_out;
@@ -1289,5 +1063,5 @@
 
     /* Get active remote certificate */
-    certs = gnutls_certificate_get_peers(ssock->session, &certslen);
+    certs = gnutls_certificate_get_peers(gssock->session, &certslen);
     if (certs == NULL || certslen == 0)
         goto peer_out;
